import random, os

# Print string 

def PrettyPrint(s):
    N = len(s)

    buf = '\n' + '|' + (4*N-1)*'-' + '|' + '\n' + '|'
    for i in range(N): buf += '{:03d}|'.format(i)
    buf += '\n' + '|' + (4*N-1)*'-' + '|' + '\n' + ' '
    for c in s: buf += '{:^3s} '.format(c)
    buf += '\n' + '|' + (4*N-1)*'-' + '|' + '\n' + '|'
    for i in range(-N,0): buf += '{:03d}|'.format(i)
    buf += '\n' + '|' + (4*N-1)*'-' + '|' + '\n'

    print(buf)

# Nouns to choose from

nouns = []

with open('words.txt', 'r') as fh:
    for line in fh:
        w = line[:-1]
        nouns.append(w)

# Practice slicing

while True:

# Form a 3-word sentence

    s = '-'.join([nouns[random.randrange(0, len(nouns))] for i in range(3)])
    N = len(s)

# The start and stop indices can be either empty of in [1, N-1] or in [-N, -1]
# Pick the step as either empty or in [2, 5] or in [-3, -1]

# Print the sentence with indices on top and bottom

    os.system('clear')
    PrettyPrint(s)

#   Ask an easy question, i.e. the character at a particular position in [-N, N-1]

    pos = random.randint(-N, N-1)
    target = s[pos]

    ans = input('Here is an easy question. What is s[' + str(pos) + '] ? ')

    if ans == target:
        print('Correct!')
    else:
        print('Nope. The correct answer is \'{}\''.format(target))

#   Ask a moderate question of the form s[i:j]

    choice = random.randint(0,2)
    if choice == 1:
        i = random.randint(0,N-1)
    elif choice == 2:
        i = random.randint(-N,-1)
    else:
        i = None

    buf = 's['
    if choice: buf += str(i)
    buf += ':'

    choice = random.randint(0,2)
    if choice == 1:
        j = random.randint(0,N-1)
    elif choice == 2:
        j = random.randint(-N,-1)
    else:
        j = None

    if choice: buf += str(j)
    buf += ']'

    if i is None and j is None:
        target = s[:]
    elif j is None:
        target = s[i:]
    elif i is None:
        target = s[:j]
    else:
        target = s[i:j]
        
    print()
    ans = input('Here is a moderate question. What is ' + buf + ' ? ')

    if ans == target:
        print('Correct!')
    else:
        print('Nope. The correct answer is \'{}\''.format(target))

#   Ask a difficult question of the form s[i:j:step]

    choice = random.randint(0,2)
    if choice == 1:
        i = random.randint(0,N-1)
    elif choice == 2:
        i = random.randint(-N,-1)
    else:
        i = None

    buf = 's['
    if choice: buf += str(i)
    buf += ':'

    choice = random.randint(0,2)
    if choice == 1:
        j = random.randint(0,N-1)
    elif choice == 2:
        j = random.randint(-N,-1)
    else:
        j = None

    if choice: buf += str(j)
    buf += ':'
    
    choice = random.randint(1,2)
    if choice == 1:
        t = random.randint(2, 5)
    else:
        t = random.randint(-5,-1)

    buf += str(t) + ']'

    if i is None and j is None:
        target = s[::t]
    elif j is None:
        target = s[i::t]
    elif i is None:
        target = s[:j:t]
    else:
        target = s[i:j:t]

    print()
    ans = input('Here is a difficult question. What is ' + buf + ' ? ')

    if ans == target:
        print('Correct!')
    else:
        print('Nope. The correct answer is \'{}\''.format(target))

#   Play again?

    print()
    ans = input('Play again [y/n]: ')
    if ans not in 'yY':
        break

print()
print('Thank you for playing!')
